Description

This patch fixes the following problems when specifying alt text for attached images in Textile format.

When a description is set for an attached image, the specified alt text is ignored and the description of the attached image takes

effect.

Incorrect img tags are generated with duplicate definitions of alt and title attributes.

!ruby-logo.png(alt text)!

 When “description” is set in the description of the attached image ruby-logo.png, the result of the above Textile is as follows

Wiki (when hovering over the image) Generated HTML

before_wiki.png 
<img src="/attachments/download/31/logo.png" 

  title="description" alt="description" 

  loading="lazy" 

  title="alt text" alt="alt text" /></p>

The current implementation expects to generate an img tag with “alt text” applied to the alt and title attributes, but actually generates

an img tag with “description” applied.

This is due to the fact that the img tag defines two alt attributes (title attribute) with the values “alt text” and “description”; the HTML

specification does not allow duplicate attributes (13.1.2.3 Attributes), and attributes defined later are ignored.

The result after applying the attached patch is as follows

Wiki (when hovering over the image) Generated HTML

after_wiki.png 
<img src="/attachments/download/31/logo.png" 

  title="alt text" alt="alt text" 

  loading="lazy" /></p>

The CommonMark format should not be affected by this problem. Please see the attached test code for the first and second patches.

My environment is as follows

Environment:

  Redmine version                5.1.2.devel

  Ruby version                   3.3.1-p55 (2024-04-23) [x86_64-linux]

  Rails version                  7.1.2

  Environment                    development

  Database adapter               SQLite

  Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

  Mailer delivery                smtp

Redmine settings:

  Redmine theme                  Default

SCM:

  Subversion                     1.14.2

  Mercurial                      6.3.2
  Cvs                            1.12.13

  Bazaar                         3.3.2

  Git                            2.39.2

  Filesystem                     

Redmine plugins:

  no plugin installed

Associated revisions

Revision 22844 - 2024-05-24 04:16 - Go MAEDA

Add tests for current alt attribute behavior in images (#40650).

Patch by Katsuya HIDAKA (@hidakatsuya).

Revision 22845 - 2024-05-24 04:52 - Go MAEDA

Fix duplicated alt and title attributes for attached images in Textile formatter (#40650).

Patch by Katsuya HIDAKA (@hidakatsuya).

History

#1 - 2024-05-16 10:57 - Go MAEDA

- Tracker changed from Patch to Defect

- Target version set to 6.0.0

Setting the target version to 6.0.0.

#2 - 2024-05-24 04:53 - Go MAEDA

- Subject changed from Fix alt and title attributes when alt text is specified for attached images in Textile format. to Fix duplicate alt and title attributes

when alt text is specified for attached images in Textile formatter

- Category changed from Wiki to Text formatting

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patches in r22844 and r22845.

Files

before_wiki.png 38.1 KB 2024-05-01 Katsuya HIDAKA

after_wiki.png 37.8 KB 2024-05-01 Katsuya HIDAKA

0001-Add-tests-for-current-alt-attribute-behavior-in-images.patch 4.34 KB 2024-05-01 Katsuya HIDAKA

0002-Fix-alt-and-title-attributes-for-attached-images-in-Wiki.patch 3.34 KB 2024-05-01 Katsuya HIDAKA
